package org.nakedobjects.nof.reflect.help;

import org.nakedobjects.nof.reflect.peer.ActionPeer;
import org.nakedobjects.nof.reflect.peer.OneToManyPeer;
import org.nakedobjects.nof.reflect.peer.OneToOnePeer;
import org.nakedobjects.nof.reflect.peer.ReflectionPeerFactory;
import org.nakedobjects.nof.reflect.peer.ValuePeer;


public class HelpPeerFactory implements ReflectionPeerFactory {
    private HelpManager manager;

    public void setHelpManager(final HelpManager manager) {
        this.manager = manager;
    }

    /**
     * Expose as a .NET property
     * 
     * @property
     */
    public void set_HelpManager(final HelpManager manager) {
        setHelpManager(manager);
    }

    public ActionPeer createAction(final ActionPeer peer) {
        return new ActionHelp(peer, manager);
    }

    public OneToManyPeer createField(final OneToManyPeer peer) {
        return new OneToManyHelp(peer, manager);
    }

    public OneToOnePeer createField(final OneToOnePeer peer) {
        return new OneToOneHelp(peer, manager);
    }
    
    public ValuePeer createField(final ValuePeer peer) {
        return new ValueHelp(peer, manager);
    }

    public void init() {
        manager.init();
    }

    public void shutdown() {
        manager.shutdown();
    }
}
// Copyright (c) Naked Objects Group Ltd.
