package org.nakedobjects.nof.reflect.i18n;

import org.nakedobjects.nof.reflect.peer.ActionPeer;
import org.nakedobjects.nof.reflect.peer.OneToManyPeer;
import org.nakedobjects.nof.reflect.peer.OneToOnePeer;
import org.nakedobjects.nof.reflect.peer.ReflectionPeerFactory;
import org.nakedobjects.nof.reflect.peer.ValuePeer;


public class I18nPeerFactory implements ReflectionPeerFactory {
    private I18nManager manager;

    public void setI18nManager(final I18nManager manager) {
        this.manager = manager;
    }

    /**
     * Expose as a .NET property
     * 
     * @property
     */
    public void set_I18nManager(final I18nManager manager) {
        setI18nManager(manager);
    }

    public ActionPeer createAction(final ActionPeer peer) {
        return new ActionI18n(peer, manager);
    }

    public OneToManyPeer createField(final OneToManyPeer peer) {
        return new OneToManyI18n(peer, manager);
    }

    public OneToOnePeer createField(final OneToOnePeer peer) {
        return new OneToOneI18n(peer, manager);
    }

    public ValuePeer createField(final ValuePeer peer) {
        return new ValueI18n(peer, manager);
    }

    public void init() {
        manager.init();
    }

    public void shutdown() {
        manager.shutdown();
    }
}
// Copyright (c) Naked Objects Group Ltd.
