package org.nakedobjects.nof.reflect.peer;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.security.Session;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.util.DebugString;


public abstract class AbstractOneToOnePeer implements OneToOnePeer {
    private final OneToOnePeer decorated;

    public AbstractOneToOnePeer(final OneToOnePeer local) {
        this.decorated = local;
    }

    public void clearAssociation(final NakedObject inObject, final NakedObject associate) {
        decorated.clearAssociation(inObject, associate);
    }

    public void debugData(final DebugString debugString) {
        decorated.debugData(debugString);
    }

    public NakedObject getAssociation(final NakedObject inObject) {
        return decorated.getAssociation(inObject);
    }
    
    public String getBusinessKeyName() {
        return decorated.getBusinessKeyName();
    }

    public NakedObject getDefault(NakedObject target) {
        return decorated.getDefault(target);
    }
    
    public String getDescription() {
        return decorated.getDescription();
    }

    public Object getExtension(final Class cls) {
        return decorated.getExtension(cls);
    }

    public Class[] getExtensions() {
        return decorated.getExtensions();
    }

    public String getHelp() {
        return decorated.getHelp();
    }

    public MemberIdentifier getIdentifier() {
        return decorated.getIdentifier();
    }

    public String getName() {
        return decorated.getName();
    }

    public Object[] getOptions(NakedReference target) {
        return decorated.getOptions(target);
    }
    
    public NakedObjectSpecification getSpecification() {
        return decorated.getSpecification();
    }

    public void initAssociation(final NakedObject inObject, final NakedObject associate) {
        decorated.initAssociation(inObject, associate);
    }

    public Consent isAssociationValid(final NakedObject inObject, final NakedObject value) {
        return decorated.isAssociationValid(inObject, value);
    }

    public boolean isPersisted() {
        return decorated.isPersisted();
    }

    public boolean isEmpty(final NakedObject inObject) {
        return decorated.isEmpty(inObject);
    }

    public boolean isMandatory() {
        return decorated.isMandatory();
    }
    
    public boolean isOptionEnabled() {
        return decorated.isOptionEnabled();
    }

    public boolean isVisibleDeclaratively() {
        return decorated.isVisibleDeclaratively();
    }
    
    public boolean isVisibleForSession(final Session session) {
        return decorated.isVisibleForSession(session);
    }
    
    public boolean isVisible(final NakedReference target) {
        return decorated.isVisible(target);
    }
    
    public Consent isUsableDeclaratively() {
        return decorated.isUsableDeclaratively();
    }

    public Consent isUsableForSession(
            Session session) {
        return decorated.isUsableForSession(session);
    }

    public Consent isUsable(final NakedReference target) {
        return decorated.isUsable(target);
    }
    
    public void setAssociation(final NakedObject inObject, final NakedObject associate) {
        decorated.setAssociation(inObject, associate);
    }
}
// Copyright (c) Naked Objects Group Ltd.
