package org.nakedobjects.nof.reflect.peer;

import org.nakedobjects.noa.adapter.Naked;
import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.reflect.NakedObjectAction;
import org.nakedobjects.noa.spec.NakedObjectSpecification;



public interface ActionPeer extends MemberPeer {
    
    NakedObjectSpecification getOnType();

    NakedObjectSpecification getReturnType();

    NakedObjectAction.Target getTarget();
    NakedObjectAction.Type getType();

    boolean isOnInstance();

    //////////////// execute, consent /////////////////

    Naked execute(NakedReference target, Naked[] parameters) throws ReflectiveActionException;

    Consent isParameterSetValidImperatively(NakedReference target, Naked[] parameters);

    
    //////////////// Parameters /////////////////
    
    int getParameterCount();
    ActionParamPeer[] getParameters();
    
    /**
     * @deprecated - use {@link #getParameters()}
     * @return
     */
    String[] getParameterNames();
    /**
     * @deprecated - use {@link #getParameters()}
     * @return
     */
    NakedObjectSpecification[] getParameterTypes();
    /**
     * @deprecated - use {@link #getParameters()}
     * @return
     */
    String[] getParameterDescriptions();
    /**
     * @deprecated - use {@link #getParameters()}
     * @return
     */
    boolean[] getOptionalParameters();
    
    /**
     * @deprecated - use {@link #getParameters()}
     * @return
     */
    int[] getParameterTypicalLengths();
    /**
     * @deprecated - use {@link #getParameters()}
     * @return
     */
    int[] getParameterMaxLengths();
    /**
     * @deprecated - use {@link #getParameters()}
     * @return
     */
    int[] getParameterNoLines();
    /**
     * @deprecated - use {@link #getParameters()}
     * @return
     */
    boolean[] canParametersWrap();
    /**
     * @deprecated - use {@link #getParameters()}
     * @return
     */
    Object[] getParameterDefaults(NakedReference target);
    /**
     * @deprecated - use {@link #getParameters()}
     * @return
     */
    Object[][] getParameterOptions(NakedReference target);


    
}
// Copyright (c) Naked Objects Group Ltd.
