package org.nakedobjects.nof.reflect.perspective;

import org.nakedobjects.noa.adapter.Naked;
import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.security.Session;
import org.nakedobjects.nof.core.reflect.Allow;
import org.nakedobjects.nof.core.util.DebugString;
import org.nakedobjects.nof.core.util.UnexpectedCallException;
import org.nakedobjects.nof.reflect.peer.FieldPeer;


abstract class PerspectiveFieldPeer implements FieldPeer {

    public void debugData(DebugString debugString) {
        debugString.append("perspective field peer " + getClass());
    }

    public String getBusinessKeyName() {
        return "";
    }
    
    public Naked getDefault(NakedReference target) {
        throw new UnexpectedCallException();
    }

    public String getDescription() {
        return "";
    }

    public Object getExtension(Class cls) {
        return null;
    }

    public Class[] getExtensions() {
        return new Class[0];
    }

    public String getHelp() {
        return "";
    }

    public Object[] getOptions(NakedReference target) {
        return null;
    }

    public boolean isPersisted() {
        return true;
    }

    public boolean isEmpty(NakedObject inObject) {
        return false;
    }

    public boolean isMandatory() {
        return false;
    }

    public Consent isUsable(NakedReference target) {
        return Allow.DEFAULT;
    }

    public Consent isUsableDeclaratively() {
        return Allow.DEFAULT;
    }

    public Consent isUsableForSession(
            Session session) {
        return Allow.DEFAULT;
    }


    public boolean isVisible(NakedReference target) {
        return true;
    }

    public boolean isVisibleDeclaratively() {
        return true;
    }

    public boolean isVisibleForSession(Session session) {
        return true;
    }
}

// Copyright (c) Naked Objects Group Ltd.
