package org.nakedobjects.nof.reflect.perspective;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.reflect.NakedObjectAction;
import org.nakedobjects.noa.reflect.NakedObjectField;
import org.nakedobjects.noa.reflect.NakedObjectAction.Type;
import org.nakedobjects.nof.core.context.NakedObjectsContext;
import org.nakedobjects.nof.core.context.Perspective;
import org.nakedobjects.nof.reflect.spec.AbstractSpecification;
import org.nakedobjects.nof.reflect.spec.ReflectionPeerBuilder;


public class PerspectiveSpecification extends AbstractSpecification {
    public NakedObjectAction[] getClassActions(Type type) {
        return new NakedObjectAction[0];
    }

    public NakedObjectField getField(String name) {
        if (name.equals("name")) {
            return fields[0];
        } else if (name.equals("services")) {
            return fields[1];
        } else if (name.equals("objects")) {
            return fields[2];
        } else if (name.equals("user")) {
            return fields[3];
        } else {
            return null;
        }
    }

    public String getIconName(NakedReference object) {
        return "perspective";
    }

    public NakedObjectAction[] getObjectActions(Type type) {
        return new NakedObjectAction[0];
    }

    public String getPluralName() {
        return "Perspectives";
    }

    public String getShortName() {
        return "Perspective";
    }

    public String getSingularName() {
        return "Perspective";
    }

    public String getTitle(NakedObject object) {
        return ((Perspective) object.getObject()).title();
    }

    public void introspect(ReflectionPeerBuilder builder) {
        className = Perspective.class.getName();
        fields = new NakedObjectField[] { builder.createField(new NamePeer()),
                builder.createField(new ServicesPeer()), builder.createField(new ObjectsPeer()),
                builder.createField(new UserNamePeer()), };
        superClassSpecification = NakedObjectsContext.getReflector().loadSpecification(Object.class);
        superClassSpecification.addSubclass(this);
    }

    public String getDescription() {
        return "Perspective";
    }

}

// Copyright (c) Naked Objects Group Ltd.
