package org.nakedobjects.nof.reflect.perspective;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.adapter.NakedValue;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.reflect.Formatter;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.context.NakedObjectsContext;
import org.nakedobjects.nof.core.context.Perspective;
import org.nakedobjects.nof.core.reflect.Allow;
import org.nakedobjects.nof.reflect.peer.ValuePeer;


abstract class PerspectiveValuePeer extends PerspectiveFieldPeer implements ValuePeer {
    private NakedObjectSpecification stringSpec = NakedObjectsContext.getReflector().loadSpecification(String.class);

    public boolean canClear() {
        return false;
    }
    
    public boolean canWrap() {
        return false;
    }
    
    public void clearValue(NakedObject inObject) {}

    public String getBusinessKeyName() {
        return "";
    }
    
    public NakedValue getDefault(NakedObject target) {
        return null;
    }
    
    public Formatter getFormatter() {
        return null;
    }
    
    public int getMaximumLength() {
        return 0;
    }

    public int getNoLines() {
        return 0;
    }

    public NakedObjectSpecification getSpecification() {
        return stringSpec;
    }

    public int getTypicalLineLength() {
        return 0;
    }

    public final NakedValue getValue(NakedObject inObject) {
        String name = getValue(((Perspective) inObject.getObject()));
        if (name == null) {
            // return new StringAdapter();
            return NakedObjectsContext.getObjectLoader().createValueInstance(stringSpec);
        } else {
            return NakedObjectsContext.getObjectLoader().createAdapterForValue(name);
        }
    }

    protected abstract String getValue(Perspective perspective);

    public void initValue(NakedObject inObject, NakedValue val) {
        setValue((Perspective) inObject.getObject(), (String) val.getObject());
    }

    public boolean isOptionEnabled() {
        return false;
    }

    public Consent isValueValid(NakedObject inObject, NakedValue value) {
        return Allow.DEFAULT;
    }

    public final void setValue(NakedObject inObject, NakedValue val) {
        setValue((Perspective) inObject.getObject(), (String) val.getObject());
    }

    protected abstract void setValue(Perspective perspective, String associate);
}

// Copyright (c) Naked Objects Group Ltd.
