package org.nakedobjects.nof.reflect.remote.data;

import java.util.Properties;

import org.nakedobjects.noa.adapter.Oid;
import org.nakedobjects.noa.security.Session;
import org.nakedobjects.object.RequiresSetup;


public interface Distribution extends RequiresSetup {
    ObjectData[] clearAssociation(Session session, String fieldIdentifier, IdentityData target, IdentityData associate);

    ObjectData[] clearValue(Session session, String fieldIdentifier, IdentityData target);

    ClientActionResultData executeClientAction(Session session, ReferenceData[] changes, int types[]);

    ServerActionResultData executeServerAction(
            Session session,
            String actionType,
            String actionIdentifier,
            ReferenceData target,
            Data[] parameters);

    ObjectData[] findInstances(Session session, CriteriaData criteria);

    ObjectData getObject(Session session, Oid oid, String specificationName);

    boolean hasInstances(Session session, String specificationName);

    IdentityData oidForService(Session session, String id);

    Data resolveField(Session session, IdentityData data, String fieldName);

    ObjectData resolveImmediately(Session session, IdentityData target);

    ObjectData[] setAssociation(Session session, String fieldIdentifier, IdentityData target, IdentityData associate);

    ObjectData[] setValue(Session session, String fieldIdentifier, IdentityData target, ValueData value);

    Properties getProperties();

    Session authenticate(String data);

    boolean authoriseUsability(Session session, String data);

    boolean authoriseVisibility(Session session, String data);

    void closeSession(Session session);
}
// Copyright (c) Naked Objects Group Ltd.
