package org.nakedobjects.nof.reflect.security;

import org.nakedobjects.noa.security.Session;
import org.nakedobjects.nof.reflect.peer.MemberIdentifier;
import org.nakedobjects.object.RequiresSetup;


/**
 * Authorises the user in the current session view and use members of an object.
 */
public interface AuthorisationManager extends RequiresSetup {

    /**
     * Returns true when the user represented by the specified session is authorised to view the member of the
     * class/object represented by the member identifier. Normally the view of the specified field, or the
     * display of the action will be suppress if this returns false.
     */
    boolean isVisible(Session session, MemberIdentifier identifier);

    /**
     * Returns true when the use represented by the specified session is authorised to change the field
     * represented by the member identifier. Normally the specified field will be not appear editable if this
     * returns false.
     */
    boolean isEditable(Session session, MemberIdentifier identifier);
}
// Copyright (c) Naked Objects Group Ltd.
