package org.nakedobjects.nof.reflect.spec;

import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.reflect.NakedObjectMember;
import org.nakedobjects.nof.core.util.NameConvertor;


public abstract class AbstractNakedObjectMember implements NakedObjectMember {
    protected final String defaultName;
    private final String id;

    protected AbstractNakedObjectMember(final String id) {
        if (id == null) {
            throw new IllegalArgumentException("Name must always be set");
        }
        this.id = id;
        this.defaultName = NameConvertor.naturalName(id);
    }

    public String getId() {
        return id;
    }

    public String toString() {
        return "id=" + getId() + ",name='" + getName() + "'";
    }
    
    public final boolean isVisible() {
        return isVisibleDeclaratively() && isVisibleForSession();
    }

    public final Consent isUsable() {
        Consent usableDeclaratively = isUsableDeclaratively();
        if (usableDeclaratively.isVetoed()) {
            return usableDeclaratively;
        }
        return isUsableForSession();
    }



}
// Copyright (c) Naked Objects Group Ltd.
