package org.nakedobjects.nof.reflect.spec;

import org.nakedobjects.noa.adapter.Naked;
import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.reflect.NakedObjectAction;
import org.nakedobjects.noa.reflect.NakedObjectActionParameter;
import org.nakedobjects.noa.reflect.NakedObjectActionParameter.Filter;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.reflect.Allow;
import org.nakedobjects.nof.core.util.UnexpectedCallException;


public class ActionSet implements NakedObjectAction {
    
    private final String name;
    private final String id;
    private final NakedObjectAction[] actions;

    public ActionSet(final String id, final String name, final NakedObjectAction[] actions) {
        this.id = id;
        this.name = name;
        this.actions = actions;
    }

    public boolean[] canParametersWrap() {
        return new boolean[0];
    }

    public String debugData() {
        return "";
    }

    public Naked execute(final NakedReference target, final Naked[] parameters) {
        throw new UnexpectedCallException();
    }

    public NakedObjectAction[] getActions() {
        return actions;
    }

    public Naked[] getDefaultParameterValues(NakedReference target) {
        throw new UnexpectedCallException();
    }
    
    public String getDescription() {
        return "";
    }
    
    public Object getExtension(final Class cls) {
        return null;
    }

    public Class[] getExtensions() {
        return new Class[0];
    }

    public String getHelp() {
        return "";
    }

    public String getId() {
        return id;
    }

    public String getName() {
        return name;
    }
    
    public NakedObjectSpecification getOnType() {
        return null;
    }
    
    public Naked[][] getOptions(NakedReference target) {
        throw new UnexpectedCallException();
    }
    
    public int getParameterCount() {
        return 0;
    }
    
    public String[] getParameterDescriptions() {
        return null;
    }
    
    public int[] getParameterMaxLengths() {
        return new int[0];
    }

    public String[] getParameterNames() {
        return null;
    }

    public int[] getParameterNoLines() {
        return new int[0];
    }

    public NakedObjectSpecification[] getParameterTypes() {
        return new NakedObjectSpecification[0];
    }

    public int[] getParameterTypicalLengths() {
        return new int[0];
    }

    public boolean[] getOptionalParameters() {
        return null;
    }

    public NakedObjectActionParameter[] getParameters() {
        return new NakedObjectActionParameter[0];
    }

    public NakedObjectActionParameter[] getParameters(
            Filter filter) {
        return new NakedObjectActionParameter[0];
    }

    public NakedObjectSpecification getReturnType() {
        return null;
    }

    public Target getTarget() {
        return DEFAULT;
    }

    public Type getType() {
        return SET;
    }

    public boolean hasReturn() {
        return false;
    }

    public boolean isOnInstance() {
        return false;
    }
    
    public boolean isContributedMethodWithSuitableParameter() {
        return false;
    }

    public Consent isParameterSetValid(final NakedReference object, final Naked[] parameters) {
        throw new UnexpectedCallException();
    }

    public Consent isParameterSetValidDeclaratively(
            NakedReference object,
            Naked[] parameters) {
        throw new UnexpectedCallException();
    }

    public Consent isParameterSetValidImperatively(
            NakedReference object,
            Naked[] parameters) {
        throw new UnexpectedCallException();
    }

    public Consent isUsable(final NakedReference target) {
        return Allow.DEFAULT;
    }

    public Consent isUsable() {
        Consent usableDeclaratively = isUsableDeclaratively();
        if (usableDeclaratively.isVetoed()) {
            return usableDeclaratively;
        }
        return isUsableForSession();
    }

    public Consent isUsableDeclaratively() {
        return Allow.DEFAULT;
    }

    public Consent isUsableForSession() {
        return Allow.DEFAULT;
    }


    public boolean isVisible() {
        return isVisibleDeclaratively() && isVisibleForSession();
    }

    public boolean isVisibleDeclaratively() {
        return true;
    }

    public boolean isVisibleForSession() {
        return true;
    }

    public boolean isVisible(final NakedReference target) {
        return true;
    }

    public NakedReference realTarget(NakedReference target) {
        return null;
    }

    /**
     * Always returns <tt>null</tt>.
     */
    public NakedObjectSpecification getSpecification() {
        return null;
    }



}
// Copyright (c) Naked Objects Group Ltd.
