package org.nakedobjects.nof.reflect.spec;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.reflect.NakedObjectAction;
import org.nakedobjects.noa.reflect.ValueActionParameter;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.reflect.peer.ActionParamPeer;

public class DefaultValueActionParameter extends AbstractActionParameter implements
        ValueActionParameter {

    /**
     * For Dummy implementations.
     * @param name
     */
    public DefaultValueActionParameter(
            int number, 
            NakedObjectAction nakedObjectAction, 
            final ActionParamPeer peer, 
            NakedObjectSpecification spec, 
            String name, 
            boolean optional) {
        super(number, nakedObjectAction, peer, spec, name, null, optional);
    }

    public DefaultValueActionParameter(
            int number, 
            NakedObjectAction nakedObjectAction, 
            final ActionParamPeer peer, 
            NakedObjectSpecification spec, 
            String name, String description, 
            boolean optional, 
            int typicalLength, int maxLength, 
            int noLines, boolean canWrap) {
        super(number, nakedObjectAction, peer, spec, name, description, optional);
        setNoLines(noLines);
        setMaxLength(maxLength);
        setTypicalLength(typicalLength);
        setCanWrap(canWrap);
    }

    public boolean isValue() {
        return true;
    }

    private int noLines;
    public int getNoLines() {
        return noLines;
    }
    public void setNoLines(
            int noLines) {
        this.noLines = noLines;
    }

    private boolean canWrap; 
    public boolean canWrap() {
        return canWrap;
    }
    public void setCanWrap(
            boolean canWrap) {
        this.canWrap = canWrap;
    }

    
    private int maxLength;
    public int getMaximumLength() {
        return maxLength;
    }
    public void setMaxLength(
            int maxLength) {
        this.maxLength = maxLength;
    }
    
    
    private int typicalLength;
    public int getTypicalLineLength() {
        return typicalLength;
    }
    public void setTypicalLength(
            int typicalLength) {
        this.typicalLength = typicalLength;
    }

    /**
     * TODO: need to be able to validate parameters individually, eg if have
     * <tt>RegEx</tt> annotation; should delegate to the Check framework instead. 
     */
    public String isValid(
            NakedObject nakedObject,
            Object proposedValue) {
        return null;
    }



}
