package org.nakedobjects.nof.reflect.transaction;

import org.apache.log4j.Logger;
import org.nakedobjects.noa.adapter.Naked;
import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.persist.NakedObjectPersistor;
import org.nakedobjects.nof.core.context.NakedObjectsContext;
import org.nakedobjects.nof.reflect.peer.AbstractActionPeer;
import org.nakedobjects.nof.reflect.peer.ActionPeer;
import org.nakedobjects.nof.reflect.peer.ReflectiveActionException;


public class ActionTransaction extends AbstractActionPeer {
    private final static Logger LOG = Logger.getLogger(ActionTransaction.class);

    public ActionTransaction(final ActionPeer decorated) {
        super(decorated);
    }

    public Naked execute(final NakedReference object, final Naked[] parameters) throws ReflectiveActionException {
        NakedObjectPersistor persistor = NakedObjectsContext.getObjectPersistor();

        try {
            persistor.startTransaction();

            /*
             * TODO the object that we are invoking this method on, and the parameters, need to be part of the
             * transaction, and not the same objects that other clients are using.
             */
            NakedReference transactionObject;
            Naked[] transactionParameters = new Naked[parameters == null ? 0 : parameters.length];
            /*
             * if (object.isPersistent()) { transactionObject = objectManager.getObject(object.getOid(),
             * object.getSpecification()); for (int i = 0; i < transactionParameters.length; i++) { Naked
             * parameter = (Naked) parameters[i]; if(parameter != null) { Oid parameterOid = parameter == null ?
             * null : parameter.getOid(); transactionParameters[i] = parameterOid == null ? parameter :
             * objectManager.getObject(parameterOid, parameter .getSpecification());
             * 
             * Assert.assertEquals(parameters[i],
             * NakedObjects.getPojoAdapterFactory().createAdapter(transactionParameters[i].getObject())); } } }
             * else {
             */// non-persistent
            transactionObject = object;
            transactionParameters = parameters == null ? new Naked[0] : parameters;
            // }

            Naked result = super.execute(transactionObject, transactionParameters);

            persistor.saveChanges();
            persistor.endTransaction();

            return result;
        } catch (RuntimeException e) {
            LOG.info("exception executing " + getIdentifier() + "; aborting transaction");
            try {
                persistor.abortTransaction();
            } catch (Exception e2) {
                LOG.error("failure during abort", e2);
            }
            throw e;
        }
    }

}
// Copyright (c) Naked Objects Group Ltd.
