package org.nakedobjects.nof.reflect.transaction;

import org.nakedobjects.nof.reflect.peer.ActionPeer;
import org.nakedobjects.nof.reflect.peer.OneToManyPeer;
import org.nakedobjects.nof.reflect.peer.OneToOnePeer;
import org.nakedobjects.nof.reflect.peer.ReflectionPeerFactory;
import org.nakedobjects.nof.reflect.peer.ValuePeer;


class TransactionPeerFactory implements ReflectionPeerFactory {
    public ActionPeer createAction(final ActionPeer peer) {
        return new ActionTransaction(peer);
    }

    public OneToManyPeer createField(final OneToManyPeer peer) {
        return new OneToManyTransaction(peer);
    }

    public OneToOnePeer createField(final OneToOnePeer peer) {
        return new OneToOneTransaction(peer);
    }
    
    public ValuePeer createField(final ValuePeer peer) {
        return new ValueTransaction(peer);
    }
    
    public void init() {}

    public void shutdown() {}
}
// Copyright (c) Naked Objects Group Ltd.
